=== modified file '.bzrignore'
--- .bzrignore	2007-09-02 15:42:18 +0000
+++ .bzrignore	2008-06-28 20:24:16 +0000
@@ -10,3 +10,4 @@
 bzr-gtk.trunk-matkor.e3p
 bzr-gtk.trunk-matkor.e3s
 bzr-gtk.trunk-matkor.e3t
+credits.pickle

=== modified file 'HACKING'
--- HACKING	2007-07-15 15:05:06 +0000
+++ HACKING	2008-07-17 11:51:03 +0000
@@ -8,4 +8,8 @@
 (http://developer.gnome.org/projects/gup/hig/) should be followed where 
 possible.
 
+Several parts of bzr-gtk are currently using glade. However, we are slowly
+trying to move away from glade so please don't add new code that uses glade and
+try to remove the use of glade.
+
 Please update the NEWS file when closing bugs or adding new features.

=== modified file 'NEWS'
--- NEWS	2008-06-06 18:04:45 +0000
+++ NEWS	2008-07-01 21:56:25 +0000
@@ -4,18 +4,52 @@
 
   * Added Refresh menu option with F5 keyboard shortcut (Russ Brown)
 
+  * Show progress bars in bzr viz window (Chad Miller, Jelmer Vernooij)
+
+  * Added menu option for indexing branches if bzr-search is present.
+    (Jelmer Vernooij)
+
+  * Add "Send Merge Directive" button in bzr viz. (Jelmer Vernooij)
+
  BUG FIXES
 
   * Replace _() calls by _i18n() calls. (Vincent Ladeuil, #187283)
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
+  * Fix history mode button. (Jasper Groenewegen, #144962)
+
+  * Fixed handle-patch script. (Jelmer Vernooij)
+
+  * Fix import in olive. (Jelmer Vernooij, #223935)
+
+  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
+
+  * Remove use of upstream removed Repository.revision_parents() 
+    (Jelmer Vernooij)
+
+  * List network drives in Olive. (Kevin Light, #244308)
+
+ CHANGES
+
+  * Moved notify icon code to separate script. (Jelmer Vernooij)
+
+  * Verify testaments when showing signatures on revisions and
+    re-enable signature display. (Jelmer Vernooij)
+
+  * Show credits for bzr-gtk in the about dialog. (Jelmer Vernooij)
+
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from
     bzrlib.plugins.gtk. This addresses the occasional collisions with '_' used
     as an anonymous variable. (Vincent Ladeuil)
 
+  * Add test for linegraph code. (Jelmer Vernooij)
+
+  * Remove obsolete tortoisebzr tests. (Jelmer Vernooij)
+
+  * Share revision context menu and main revision menu in bzr viz. (Jelmer Vernooij)
 
 0.94.0    2008-05-04
 

=== modified file '__init__.py'
--- __init__.py	2008-06-27 16:53:56 +0000
+++ __init__.py	2008-06-27 17:10:27 +0000
@@ -15,7 +15,6 @@
 """Graphical support for Bazaar using GTK.
 
 This plugin includes:
-commit-notify     Start the graphical notifier of commits.
 gannotate         GTK+ annotate. 
 gbranch           GTK+ branching. 
 gcheckout         GTK+ checkout. 
@@ -525,77 +524,6 @@
     register_command(cmd)
 
 
-class cmd_commit_notify(GTKCommand):
-    """Run the bzr commit notifier.
-
-    This is a background program which will pop up a notification on the users
-    screen when a commit occurs.
-    """
-
-    def run(self):
-        from notify import NotifyPopupMenu
-        gtk = open_display()
-        menu = NotifyPopupMenu()
-        icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
-        icon.connect('popup-menu', menu.display)
-
-        import cgi
-        import dbus
-        import dbus.service
-        import pynotify
-        from bzrlib.bzrdir import BzrDir
-        from bzrlib import errors
-        from bzrlib.osutils import format_date
-        from bzrlib.transport import get_transport
-        if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
-            import dbus.glib
-        BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
-        bus = dbus.SessionBus()
-
-        def catch_branch(revision_id, urls):
-            # TODO: show all the urls, or perhaps choose the 'best'.
-            url = urls[0]
-            try:
-                if isinstance(revision_id, unicode):
-                    revision_id = revision_id.encode('utf8')
-                transport = get_transport(url)
-                a_dir = BzrDir.open_from_transport(transport)
-                branch = a_dir.open_branch()
-                revno = branch.revision_id_to_revno(revision_id)
-                revision = branch.repository.get_revision(revision_id)
-                summary = 'New revision %d in %s' % (revno, url)
-                body  = 'Committer: %s\n' % revision.committer
-                body += 'Date: %s\n' % format_date(revision.timestamp,
-                    revision.timezone)
-                body += '\n'
-                body += revision.message
-                body = cgi.escape(body)
-                nw = pynotify.Notification(summary, body)
-                def start_viz(notification=None, action=None, data=None):
-                    """Start the viz program."""
-                    pp = start_viz_window(branch, revision_id)
-                    pp.show()
-                def start_branch(notification=None, action=None, data=None):
-                    """Start a Branch dialog"""
-                    from bzrlib.plugins.gtk.branch import BranchDialog
-                    bd = BranchDialog(remote_path=url)
-                    bd.run()
-                nw.add_action("inspect", "Inspect", start_viz, None)
-                nw.add_action("branch", "Branch", start_branch, None)
-                nw.set_timeout(5000)
-                nw.show()
-            except Exception, e:
-                print e
-                raise
-        bus.add_signal_receiver(catch_branch,
-                                dbus_interface=BROADCAST_INTERFACE,
-                                signal_name="Revision")
-        pynotify.init("bzr commit-notify")
-        gtk.main()
-
-register_command(cmd_commit_notify)
-
-
 class cmd_gselftest(GTKCommand):
     """Version of selftest that displays a notification at the end"""
 

=== modified file 'about.py'
--- about.py	2008-04-01 09:59:41 +0000
+++ about.py	2008-06-28 20:24:16 +0000
@@ -23,15 +23,45 @@
 import bzrlib
 import gtk
 import os
+from bzrlib.branch import Branch
+from bzrlib.errors import NotBranchError, NoRepositoryPresent
+from bzrlib.trace import mutter
+
 from bzrlib.plugins.gtk import icon_path
 
+
+def read_license():
+    license_file = os.path.join(os.path.dirname(__file__), "COPYING")
+    if os.path.exists(license_file):
+        return file(license_file).read()
+    # Fall back to just license name if we can't find the file
+    return "GPLv2 or later"
+
+
+def load_credits():
+    import pickle
+    try:
+        credits = pickle.load(file("credits.pickle"))
+    except IOError:
+        credits = None
+    return credits
+
+
 class AboutDialog(gtk.AboutDialog):
     def __init__(self):
         super(AboutDialog, self).__init__()
         self.set_name("Bazaar GTK")
         self.set_version(bzrlib.plugins.gtk.version_string)
         self.set_website("http://bazaar-vcs.org/BzrGtk")
-        self.set_license("GNU GPL v2 or later")
-        self.set_icon(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        self.set_license(read_license())
+        self.set_logo(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        credits = load_credits()
+        if credits is not None:
+            (authors, documenters, artists, translators) = credits
+            self.set_authors(authors)
+            self.set_documenters(documenters)
+            self.set_artists(artists)
+            self.set_translator_credits("\n".join(translators))
         self.connect ("response", lambda d, r: d.destroy())
 
+

=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-06-29 16:11:12 +0000
+++ branchview/linegraph.py	2008-06-30 12:39:07 +0000
@@ -47,7 +47,7 @@
     def update_root_progress(step_number):
         """IFF our container received a root progress bar, then update it."""
         if root_progress is not None:
-            root_progress.update(current=step_number)
+            root_progress.update(None, current_cnt=step_number)
 
     graph_parents = {}
     ghosts = set()
@@ -75,10 +75,10 @@
     update_root_progress(2)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Removing ghosts", total=len(ghosts))
+        progress_bar.update(msg="Removing ghosts", total_cnt=len(ghosts))
         for i, ghost in enumerate(ghosts):
             if i % 25 == 0:
-                progress_bar.update(current=i)
+                progress_bar.update(None, current_cnt=i)
             for ghost_child in graph_children[ghost]:
                 graph_parents[ghost_child] = [p for p in graph_parents[ghost_child]
                                               if p not in ghosts]
@@ -118,7 +118,7 @@
     update_root_progress(3)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Finding nodes", total=len(merge_sorted_revisions))
+        progress_bar.update(msg="Finding nodes", total_cnt=len(merge_sorted_revisions))
         for (rev_index, (sequence_number,
                          revid,
                          merge_depth,
@@ -126,7 +126,7 @@
                          end_of_merge)) in enumerate(merge_sorted_revisions):
 
             if rev_index % 25 == 0:
-                progress_bar.update(current=rev_index)
+                progress_bar.update(None, current_cnt=rev_index)
             if maxnum and rev_index >= maxnum:
                 break
             revid_index[revid] = rev_index
@@ -184,10 +184,10 @@
         update_root_progress(4)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Organizing edges", total=len(branch_ids))
+            progress_bar.update(msg="Organizing edges", total_cnt=len(branch_ids))
             for i, branch_id in enumerate(branch_ids):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, current_cnt=i)
                 branch_line = branch_lines[branch_id]
                 
                 # Find the col_index for the direct parent branch. This will be the
@@ -314,10 +314,10 @@
         update_root_progress(5)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Pretifying graph", total=len(lines))
+            progress_bar.update(msg="Pretifying graph", total_cnt=len(lines))
             for i, (child_index, parent_index, line_col_indexes) in enumerate(lines):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, current_cnt=i)
                 (child_col_index, child_color) = linegraph[child_index][1]
                 (parent_col_index, parent_color) = linegraph[parent_index][1]
                 

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-06-29 16:11:12 +0000
+++ branchview/treeview.py	2008-06-30 20:11:24 +0000
@@ -16,11 +16,13 @@
 from bzrlib import ui
 
 from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk.ui import GtkProgressBar, ProgressPanel
 from linegraph import linegraph, same_branch
 from graphcell import CellRendererGraph
 from treemodel import TreeModel
 from bzrlib.revision import NULL_REVISION
 
+
 class TreeView(gtk.VBox):
 
     __gproperties__ = {
@@ -106,6 +108,10 @@
         """
         gtk.VBox.__init__(self, spacing=0)
 
+        loading_msg_widget = ProgressPanel()
+        ui.ui_factory.set_nested_progress_bar_widget(loading_msg_widget.get_progress_bar)
+        self.pack_start(loading_msg_widget, expand=False, fill=True)
+
         self.scrolled_window = gtk.ScrolledWindow()
         self.scrolled_window.set_policy(gtk.POLICY_AUTOMATIC,
                                         gtk.POLICY_AUTOMATIC)
@@ -269,8 +275,8 @@
                        should be broken.
         """
 
-        loading_progress = ui.ui_factory.nested_progress_bar()
-        loading_progress.update(msg="Loading ancestry graph", total=5)
+        self.progress_bar = ui.ui_factory.nested_progress_bar()
+        self.progress_bar.update(msg="Loading ancestry graph", total_cnt=5)
 
         try:
             if self.compact:
@@ -287,7 +293,7 @@
                                                             broken_line_length,
                                                             show_graph,
                                                             self.mainline_only,
-                                                            loading_progress)
+                                                            self.progress_bar)
 
             self.model = TreeModel(self.branch, linegraphdata)
             self.graph_cell.columns_len = columns_len
@@ -304,11 +310,9 @@
             else:
                 self.set_revision(revision)
 
-            self.emit('revisions-loaded')
-
             return False
         finally:
-            loading_progress.finished()
+            self.progress_bar.finished()
 
     def construct_treeview(self):
         self.treeview = gtk.TreeView()
@@ -392,7 +396,7 @@
         self.treeview.append_column(self.date_column)
         
         return self.treeview
-
+    
     def _on_selection_changed(self, treeview):
         """callback for when the treeview changes."""
         (path, focus) = treeview.get_cursor()
@@ -401,9 +405,9 @@
             self.emit('revision-selected')
 
     def _on_revision_selected(self, widget, event):
-        from bzrlib.plugins.gtk.revisionmenu import RevisionPopupMenu
+        from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            menu = RevisionPopupMenu(self.branch.repository, 
+            menu = RevisionMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2008-06-27 17:10:27 +0000
@@ -0,0 +1,72 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk import open_display, icon_path
+
+from notify import NotifyPopupMenu
+gtk = open_display()
+menu = NotifyPopupMenu()
+icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
+icon.connect('popup-menu', menu.display)
+
+import cgi
+import dbus
+import dbus.service
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib import errors
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+	import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+	# TODO: show all the urls, or perhaps choose the 'best'.
+	url = urls[0]
+	try:
+		if isinstance(revision_id, unicode):
+			revision_id = revision_id.encode('utf8')
+		transport = get_transport(url)
+		a_dir = BzrDir.open_from_transport(transport)
+		branch = a_dir.open_branch()
+		revno = branch.revision_id_to_revno(revision_id)
+		revision = branch.repository.get_revision(revision_id)
+		summary = 'New revision %d in %s' % (revno, url)
+		body  = 'Committer: %s\n' % revision.committer
+		body += 'Date: %s\n' % format_date(revision.timestamp,
+			revision.timezone)
+		body += '\n'
+		body += revision.message
+		body = cgi.escape(body)
+		nw = pynotify.Notification(summary, body)
+		def start_viz(notification=None, action=None, data=None):
+			"""Start the viz program."""
+			pp = start_viz_window(branch, revision_id)
+			pp.show()
+		def start_branch(notification=None, action=None, data=None):
+			"""Start a Branch dialog"""
+			from bzrlib.plugins.gtk.branch import BranchDialog
+			bd = BranchDialog(remote_path=url)
+			bd.run()
+		nw.add_action("inspect", "Inspect", start_viz, None)
+		nw.add_action("branch", "Branch", start_branch, None)
+		nw.set_timeout(5000)
+		nw.show()
+	except Exception, e:
+		print e
+		raise
+bus.add_signal_receiver(catch_branch,
+						dbus_interface=BROADCAST_INTERFACE,
+						signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== added file 'create-credits.py'
--- create-credits.py	1970-01-01 00:00:00 +0000
+++ create-credits.py	2008-06-28 20:24:16 +0000
@@ -0,0 +1,26 @@
+#!/usr/bin/python
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.branch import Branch
+from bzrlib.plugins.stats import find_credits
+
+import pickle
+
+branch = Branch.open(".")
+credits = find_credits(branch.repository, branch.last_revision())
+
+pickle.dump(credits, file("credits.pickle", 'w'))

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-06-23 08:05:19 +0000
+++ olive/__init__.py	2008-07-18 09:10:11 +0000
@@ -45,6 +45,7 @@
 from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, warning_dialog
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from guifiles import GLADEFILENAME
+from bzrlib.plugins.gtk.olive.window import OliveGui
 
 from bzrlib.plugins.gtk.diff import DiffWindow
 lazy_import(globals(), """
@@ -87,129 +88,33 @@
     program. """
     
     def __init__(self):
-        self.toplevel = gtk.glade.XML(GLADEFILENAME, 'window_main', 'olive-gtk')
-        self.window = self.toplevel.get_widget('window_main')
+        self.window = OliveGui(calling_app = self)
+        
         self.pref = Preferences()
         self.path = None
 
         # Initialize the statusbar
-        self.statusbar = self.toplevel.get_widget('statusbar')
-        self.context_id = self.statusbar.get_context_id('olive')
-        
-        # Get the main window
-        self.window_main = self.toplevel.get_widget('window_main')
-        # Get the HPaned
-        self.hpaned_main = self.toplevel.get_widget('hpaned_main')
-        # Get the TreeViews
-        self.treeview_left = self.toplevel.get_widget('treeview_left')
-        self.treeview_right = self.toplevel.get_widget('treeview_right')
-        # Get some important menu items
-        self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
-        self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
-        self.menuitem_file_bookmark = self.toplevel.get_widget('menuitem_file_bookmark')
-        self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
-        self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
-        self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
-        self.menuitem_file_annotate = self.toplevel.get_widget('menuitem_file_annotate')
-        self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
-        self.menuitem_view_show_ignored_files = self.toplevel.get_widget('menuitem_view_show_ignored_files')
-        self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
-        self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
-        self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
-        self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
-        self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
-        self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
-        self.menuitem_branch_update = self.toplevel.get_widget('menuitem_branch_update')
-        self.menuitem_branch_revert = self.toplevel.get_widget('menuitem_branch_revert')
-        self.menuitem_branch_merge = self.toplevel.get_widget('menuitem_branch_merge')
-        self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
-        self.menuitem_branch_tags = self.toplevel.get_widget('menuitem_branch_tags')
-        self.menuitem_branch_status = self.toplevel.get_widget('menuitem_branch_status')
-        self.menuitem_branch_missing = self.toplevel.get_widget('menuitem_branch_missing_revisions')
-        self.menuitem_branch_conflicts = self.toplevel.get_widget('menuitem_branch_conflicts')
-        self.menuitem_stats = self.toplevel.get_widget('menuitem_stats')
-        self.menuitem_stats_diff = self.toplevel.get_widget('menuitem_stats_diff')
-        self.menuitem_stats_log = self.toplevel.get_widget('menuitem_stats_log')
-        # Get some toolbuttons
-        #self.menutoolbutton_diff = self.toplevel.get_widget('menutoolbutton_diff')
-        self.toolbutton_diff = self.toplevel.get_widget('toolbutton_diff')
-        self.toolbutton_log = self.toplevel.get_widget('toolbutton_log')
-        self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
-        self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
-        self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
-        self.toolbutton_update = self.toplevel.get_widget('toolbutton_update')
+        self.context_id = self.window.statusbar.get_context_id('olive')
+        
+		# Get the TreeViews
+        self.treeview_left = self.window.treeview_left
+        self.treeview_right = self.window.treeview_right
+        
         # Get the drive selector
         self.combobox_drive = gtk.combo_box_new_text()
         self.combobox_drive.connect("changed", self._refresh_drives)
         
         # Get the navigation widgets
-        self.hbox_location = self.toplevel.get_widget('hbox_location')
-        self.button_location_up = self.toplevel.get_widget('button_location_up')
-        self.button_location_jump = self.toplevel.get_widget('button_location_jump')
-        self.entry_location = self.toplevel.get_widget('entry_location')
-        self.image_location_error = self.toplevel.get_widget('image_location_error')
+        self.hbox_location = self.window.locationbar
+        self.button_location_up = self.window.button_location_up
+        self.button_location_jump = self.window.button_location_jump
+        self.entry_location = self.window.entry_location
+        self.image_location_error = self.window.image_location_error
         
         # Get the History widgets
-        self.check_history = self.toplevel.get_widget('checkbutton_history')
-        self.entry_history = self.toplevel.get_widget('entry_history_revno')
-        self.button_history = self.toplevel.get_widget('button_history_browse')
-        
-        self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_window_main_destroy": gtk.main_quit,
-                "on_window_main_delete_event": self.on_window_main_delete_event,
-                "on_quit_activate": self.on_window_main_delete_event,
-                "on_about_activate": self.on_about_activate,
-                "on_menuitem_add_files_activate": self.on_menuitem_add_files_activate,
-                "on_menuitem_remove_file_activate": self.on_menuitem_remove_file_activate,
-                "on_menuitem_file_bookmark_activate": self.on_menuitem_file_bookmark_activate,
-                "on_menuitem_file_make_directory_activate": self.on_menuitem_file_make_directory_activate,
-                "on_menuitem_file_move_activate": self.on_menuitem_file_move_activate,
-                "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
-                "on_menuitem_file_annotate_activate": self.on_menuitem_file_annotate_activate,
-                "on_menuitem_view_show_hidden_files_activate": self.on_menuitem_view_show_hidden_files_activate,
-                "on_menuitem_view_show_ignored_files_activate": self.on_menuitem_view_show_ignored_files_activate,
-                "on_menuitem_view_refresh_activate": self.on_menuitem_view_refresh_activate,
-                "on_menuitem_branch_initialize_activate": self.on_menuitem_branch_initialize_activate,
-                "on_menuitem_branch_get_activate": self.on_menuitem_branch_get_activate,
-                "on_menuitem_branch_checkout_activate": self.on_menuitem_branch_checkout_activate,
-                "on_menuitem_branch_revert_activate": self.on_menuitem_branch_revert_activate,
-                "on_menuitem_branch_merge_activate": self.on_menuitem_branch_merge_activate,
-                "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
-                "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
-                "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
-                "on_menuitem_branch_update_activate": self.on_menuitem_branch_update_activate,                
-                "on_menuitem_branch_tags_activate": self.on_menuitem_branch_tags_activate,
-                "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
-                "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
-                "on_menuitem_branch_conflicts_activate": self.on_menuitem_branch_conflicts_activate,
-                "on_menuitem_stats_diff_activate": self.on_menuitem_stats_diff_activate,
-                "on_menuitem_stats_log_activate": self.on_menuitem_stats_log_activate,
-                "on_menuitem_stats_infos_activate": self.on_menuitem_stats_infos_activate,
-                "on_toolbutton_refresh_clicked": self.on_menuitem_view_refresh_activate,
-                "on_toolbutton_log_clicked": self.on_menuitem_stats_log_activate,
-                #"on_menutoolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
-                "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
-                "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
-                "on_toolbutton_update_clicked": self.on_menuitem_branch_update_activate,
-                "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
-                "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
-                "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
-                "on_treeview_left_button_release_event": self.on_treeview_left_button_release_event,
-                "on_treeview_left_row_activated": self.on_treeview_left_row_activated,
-                "on_button_location_up_clicked": self.on_button_location_up_clicked,
-                "on_button_location_jump_clicked": self.on_button_location_jump_clicked,
-                "on_entry_location_key_press_event": self.on_entry_location_key_press_event,
-                "on_checkbutton_history_toggled": self.on_checkbutton_history_toggled,
-                "on_entry_history_revno_key_press_event": self.on_entry_history_revno_key_press_event,
-                "on_button_history_browse_clicked": self.on_button_history_browse_clicked
-            }
-        
-        # Connect the signals to the handlers
-        self.toplevel.signal_autoconnect(dic)
+        self.check_history = self.window.checkbutton_history
+        self.entry_history = self.window.entry_history_revno
+        self.button_history = self.window.button_history_browse
         
         self._just_started = True
         
@@ -222,11 +127,7 @@
         self.window.move(x, y)
         # Apply paned position
         pos = self.pref.get_preference('paned_position', 'int')
-        self.hpaned_main.set_position(pos)
-        
-        # Apply menu to the toolbutton
-        #menubutton = self.toplevel.get_widget('menutoolbutton_diff')
-        #menubutton.set_menu(handler.menu.toolbar_diff)
+        self.window.hpaned_main.set_position(pos)
         
         # Now we can show the window
         self.window.show()
@@ -241,8 +142,8 @@
         self._load_left()
 
         # Apply menu state
-        self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
-        self.menuitem_view_show_ignored_files.set_active(self.pref.get_preference('ignored_files', 'bool'))
+        self.window.mb_view_showhidden.set_active(self.pref.get_preference('dotted_files', 'bool'))
+        self.window.mb_view_showignored.set_active(self.pref.get_preference('ignored_files', 'bool'))
 
         # We're starting local
         self.remote = False
@@ -375,7 +276,7 @@
         else:
             self.check_history.set_sensitive(True)
         
-        self.statusbar.push(self.context_id, path)
+        self.window.statusbar.push(self.context_id, path)
         self.entry_location.set_text(path)
         self.path = path
         return True
@@ -442,6 +343,9 @@
             # History Mode deactivated
             self.entry_history.set_sensitive(False)
             self.button_history.set_sensitive(False)
+            
+            # Return right window to normal view by acting like we jump to it
+            self.on_button_location_jump_clicked(widget)
     
     @show_bzr_error
     def on_entry_history_revno_key_press_event(self, widget, event):
@@ -508,7 +412,6 @@
     @show_bzr_error
     def on_menuitem_branch_commit_activate(self, widget):
         """ Branch/Commit... menu handler. """
-#     def __init__(self, wt, wtpath, notbranch, selected=None, parent=None):
         selected = self.get_selected_right()
         if selected:
             selected = os.path.join(self.wtpath, selected)
@@ -773,7 +676,8 @@
         else:
             branch = self.remote_branch
 
-        window = branchwin.BranchWindow(branch, branch.last_revision(), None, parent=self.window)
+        window = branchwin.BranchWindow(branch, [branch.last_revision()], None, 
+                                        parent=self.window)
         window.show()
     
     def on_menuitem_view_refresh_activate(self, widget):
@@ -919,17 +823,17 @@
     
     def on_window_main_delete_event(self, widget, event=None):
         """ Do some stuff before exiting. """
-        width, height = self.window_main.get_size()
+        width, height = self.window.get_size()
         self.pref.set_preference('window_width', width)
         self.pref.set_preference('window_height', height)
-        x, y = self.window_main.get_position()
+        x, y = self.window.get_position()
         self.pref.set_preference('window_x', x)
         self.pref.set_preference('window_y', y)
         self.pref.set_preference('paned_position',
-                                 self.hpaned_main.get_position())
+                                 self.window.hpaned_main.get_position())
         
         self.pref.write()
-        self.window_main.destroy()
+        self.window.destroy()
         
     def _load_left(self):
         """ Load data into the left panel. (Bookmarks) """
@@ -1155,74 +1059,18 @@
 
     def set_statusbar(self, message):
         """ Set the statusbar message. """
-        self.statusbar.push(self.context_id, message)
+        self.window.statusbar.push(self.context_id, message)
     
     def clear_statusbar(self):
         """ Clean the last message from the statusbar. """
-        self.statusbar.pop(self.context_id)
+        self.window.statusbar.pop(self.context_id)
     
     def set_sensitivity(self):
         """ Set menu and toolbar sensitivity. """
         if not self.remote:
-            # We're local
-            self.menuitem_branch_init.set_sensitive(self.notbranch)
-            self.menuitem_branch_get.set_sensitive(self.notbranch)
-            self.menuitem_branch_checkout.set_sensitive(self.notbranch)
-            self.menuitem_branch_pull.set_sensitive(not self.notbranch)
-            self.menuitem_branch_push.set_sensitive(not self.notbranch)
-            self.menuitem_branch_update.set_sensitive(not self.notbranch)
-            self.menuitem_branch_revert.set_sensitive(not self.notbranch)
-            self.menuitem_branch_merge.set_sensitive(not self.notbranch)
-            self.menuitem_branch_commit.set_sensitive(not self.notbranch)
-            self.menuitem_branch_tags.set_sensitive(not self.notbranch)
-            self.menuitem_branch_status.set_sensitive(not self.notbranch)
-            self.menuitem_branch_missing.set_sensitive(not self.notbranch)
-            self.menuitem_branch_conflicts.set_sensitive(not self.notbranch)
-            self.menuitem_stats.set_sensitive(not self.notbranch)
-            self.menuitem_stats_diff.set_sensitive(not self.notbranch)
-            self.menuitem_add_files.set_sensitive(not self.notbranch)
-            self.menuitem_remove_files.set_sensitive(not self.notbranch)
-            self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
-            self.menuitem_file_rename.set_sensitive(not self.notbranch)
-            self.menuitem_file_move.set_sensitive(not self.notbranch)
-            self.menuitem_file_annotate.set_sensitive(not self.notbranch)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(not self.notbranch)
-            self.toolbutton_log.set_sensitive(not self.notbranch)
-            self.toolbutton_commit.set_sensitive(not self.notbranch)
-            self.toolbutton_pull.set_sensitive(not self.notbranch)
-            self.toolbutton_push.set_sensitive(not self.notbranch)
-            self.toolbutton_update.set_sensitive(not self.notbranch)
+            self.window.set_view_to_localbranch(self.notbranch)
         else:
-            # We're remote
-            self.menuitem_branch_init.set_sensitive(False)
-            self.menuitem_branch_get.set_sensitive(True)
-            self.menuitem_branch_checkout.set_sensitive(True)
-            self.menuitem_branch_pull.set_sensitive(False)
-            self.menuitem_branch_push.set_sensitive(False)
-            self.menuitem_branch_update.set_sensitive(False)
-            self.menuitem_branch_revert.set_sensitive(False)
-            self.menuitem_branch_merge.set_sensitive(False)
-            self.menuitem_branch_commit.set_sensitive(False)
-            self.menuitem_branch_tags.set_sensitive(True)
-            self.menuitem_branch_status.set_sensitive(False)
-            self.menuitem_branch_missing.set_sensitive(False)
-            self.menuitem_branch_conflicts.set_sensitive(False)
-            self.menuitem_stats.set_sensitive(True)
-            self.menuitem_stats_diff.set_sensitive(False)
-            self.menuitem_add_files.set_sensitive(False)
-            self.menuitem_remove_files.set_sensitive(False)
-            self.menuitem_file_make_directory.set_sensitive(False)
-            self.menuitem_file_rename.set_sensitive(False)
-            self.menuitem_file_move.set_sensitive(False)
-            self.menuitem_file_annotate.set_sensitive(False)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(False)
-            self.toolbutton_log.set_sensitive(True)
-            self.toolbutton_commit.set_sensitive(False)
-            self.toolbutton_pull.set_sensitive(False)
-            self.toolbutton_push.set_sensitive(False)
-            self.toolbutton_update.set_sensitive(False)
+            self.window.set_view_to_remotebranch()
     
     def refresh_left(self):
         """ Refresh the bookmark list. """
@@ -1485,7 +1333,8 @@
         
         driveletters = []
         for drive in string.ascii_uppercase:
-            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED:
+            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED or\
+                win32file.GetDriveType(drive+':') == win32file.DRIVE_REMOTE:
                 driveletters.append(drive+':')
         return driveletters
     
@@ -1724,4 +1573,3 @@
                 return self._get_default(option)
             except KeyError:
                 return None
- 

=== modified file 'olive/add.py'
--- olive/add.py	2008-05-05 18:16:46 +0000
+++ olive/add.py	2008-06-29 18:32:05 +0000
@@ -69,20 +69,16 @@
                              _i18n('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
             try:
-                bzrlib.add.smart_add([fullpath])
+                self.wt.add([filename])
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
         elif radio_unknown.get_active():
             # Add unknown files recursively
-            fullpath = self.wt.abspath(self.wtpath)
-            
             try:
-                bzrlib.add.smart_add([fullpath], True)
+                self.wt.add(self.wt.unknowns())
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))

=== modified file 'olive/menu.py'
--- olive/menu.py	2008-05-05 18:18:08 +0000
+++ olive/menu.py	2008-06-30 12:15:06 +0000
@@ -30,13 +30,12 @@
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
-from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk import _i18n, launch
 from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, question_dialog, warning_dialog
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
 from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
 from bzrlib.plugins.gtk.diff import DiffWindow
-from launch import launch
 from bzrlib.plugins.gtk.olive import Preferences
 
 class OliveMenu:
@@ -179,7 +178,8 @@
                          _i18n('Please select a file from the list,\nor choose the other option.'))
             return
         
-        bzrlib.add.smart_add([os.path.join(directory, filename)])
+        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
+        wt.add([path])
     
     @show_bzr_error
     def annotate(self, action):

=== modified file 'olive/move.py'
--- olive/move.py	2008-05-05 18:16:46 +0000
+++ olive/move.py	2008-06-28 16:59:50 +0000
@@ -31,7 +31,7 @@
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from errors import show_bzr_error
+from bzrlib.plugins.gtk.errors import show_bzr_error
 from guifiles import GLADEFILENAME
 
 

=== added file 'olive/window.py'
--- olive/window.py	1970-01-01 00:00:00 +0000
+++ olive/window.py	2008-07-18 09:10:11 +0000
@@ -0,0 +1,452 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+# Some parts of the code are:
+# Copyright (C) 2005, 2006 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+import gtk
+import gobject
+
+from bzrlib.plugins.gtk import _i18n, icon_path
+
+
+class OliveGui(gtk.Window):
+    """ Olive main window """
+    
+    def __init__(self, calling_app):
+        # Pointer to calling instance for signal connection
+        self.signal = calling_app
+        self.iconpath = icon_path()+os.sep
+        
+        # Initialise window
+        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
+        self.set_title(_i18n("Olive - Bazaar GUI"))
+        self.set_icon_list(gtk.gdk.pixbuf_new_from_file(self.iconpath+"oliveicon2.png"),
+                           gtk.gdk.pixbuf_new_from_file(self.iconpath+"olive-gtk.png"),
+                           # Who has the svg version of the icon? Would be nice to include
+                           #gtk.gdk.pixbuf_new_from_file(self.iconpath+"olive.svg")
+                           )
+        self.set_property("width-request", 700)
+        self.set_property("height-request", 400)
+        
+        self.connect("destroy", self.destroy)
+        self.connect("delete_event", self.signal.on_window_main_delete_event)
+        
+        # Accelerator group to Quit program
+        accelgroup = gtk.AccelGroup()
+        self.add_accel_group(accelgroup)
+        self.quit_action = gtk.Action(_i18n("Quit"), None, None, gtk.STOCK_QUIT)
+        self.quit_action.connect('activate', self.signal.on_window_main_delete_event)
+        actiongroup = gtk.ActionGroup('QuitAction')
+        actiongroup.add_action_with_accel(self.quit_action, None)
+        self.quit_action.set_accel_group(accelgroup)
+        self.quit_action.connect_accelerator()
+        
+        # High level build up of window
+        self.vbox = gtk.VBox(False, 0)
+        self.add(self.vbox)
+        
+        # Menu bar
+        self._create_menubar()
+        self.vbox.pack_start(self.mb, False, False, 0)
+        
+        # Toolbar
+        self._create_toolbar()
+        self.vbox.pack_start(self.tb, False, False, 0)
+        
+        # Locationbar
+        self._create_locationbar()
+        self.vbox.pack_start(self.locationbar, False, False, 0)
+        
+        # Main area
+        self.hpaned_main = gtk.HPaned()
+        self._create_bookmarklist()
+        self.hpaned_main.add(self.scrolledwindow_left)
+        self._create_filelist()
+        self.hpaned_main.add(self.scrolledwindow_right)
+        self.vbox.pack_start(self.hpaned_main, True, True, 0)
+        
+        # Statusbar
+        self.statusbar = gtk.Statusbar()
+        self.vbox.pack_end(self.statusbar, False, False, 0)
+    
+    def show(self):
+        self.show_all()        
+    
+    def destroy(self, widget=None, data=None):
+        """ Ends the program """
+        gtk.main_quit()
+
+    def _create_menubar(self):
+        self.mb = gtk.MenuBar()
+        
+        # File menu
+        self.mb_file = gtk.MenuItem(_i18n("_File"))
+        self.mb_file_menu = gtk.Menu()
+        
+        self.mb_file_add = gtk.ImageMenuItem(gtk.STOCK_ADD, _i18n("_Add file(s)"))
+        self.mb_file_add.connect('activate', self.signal.on_menuitem_add_files_activate)
+        self.mb_file_menu.append(self.mb_file_add)
+        
+        self.mb_file_remove = gtk.ImageMenuItem(gtk.STOCK_REMOVE, _i18n("_Remove file(s)"))
+        self.mb_file_remove.connect('activate', self.signal.on_menuitem_remove_file_activate)
+        self.mb_file_menu.append(self.mb_file_remove)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_bookmark = gtk.MenuItem(_i18n("_Bookmark current directory"))
+        self.mb_file_bookmark.connect('activate', self.signal.on_menuitem_file_bookmark_activate)
+        self.mb_file_menu.append(self.mb_file_bookmark)
+        
+        self.mb_file_mkdir = gtk.MenuItem(_i18n("_Make directory"))
+        self.mb_file_mkdir.connect('activate', self.signal.on_menuitem_file_make_directory_activate)
+        self.mb_file_menu.append(self.mb_file_mkdir)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_rename = gtk.MenuItem(_i18n("_Rename"))
+        self.mb_file_rename.connect('activate', self.signal.on_menuitem_file_rename_activate)
+        self.mb_file_menu.append(self.mb_file_rename)
+        
+        self.mb_file_move = gtk.MenuItem(_i18n("_Move"))
+        self.mb_file_move.connect('activate', self.signal.on_menuitem_file_move_activate)
+        self.mb_file_menu.append(self.mb_file_move)
+        
+        self.mb_file_annotate = gtk.MenuItem(_i18n("_Annotate"))
+        self.mb_file_annotate.connect('activate', self.signal.on_menuitem_file_annotate_activate)
+        self.mb_file_menu.append(self.mb_file_annotate)
+        
+        self.mb_file_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_file_quit = self.quit_action.create_menu_item()
+        self.mb_file_menu.append(self.mb_file_quit)
+        
+        self.mb_file.set_submenu(self.mb_file_menu)
+        self.mb.append(self.mb_file)
+        
+        # View menu
+        self.mb_view = gtk.MenuItem(_i18n("_View"))
+        self.mb_view_menu = gtk.Menu()
+        
+        self.mb_view_showhidden = gtk.CheckMenuItem(_i18n("Show _hidden files"))
+        self.mb_view_showhidden.connect('activate', self.signal.on_menuitem_view_show_hidden_files_activate)
+        self.mb_view_menu.append(self.mb_view_showhidden)
+        
+        self.mb_view_showignored = gtk.CheckMenuItem(_i18n("Show _ignored files"))
+        self.mb_view_showignored.connect('activate', self.signal.on_menuitem_view_show_ignored_files_activate)
+        self.mb_view_menu.append(self.mb_view_showignored)
+        
+        self.mb_view_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_view_refresh = gtk.ImageMenuItem(gtk.STOCK_REFRESH, _i18n("_Refresh"))
+        self.mb_view_refresh.connect('activate', self.signal.on_menuitem_view_refresh_activate)
+        self.mb_view_menu.append(self.mb_view_refresh)
+        
+        self.mb_view.set_submenu(self.mb_view_menu)
+        self.mb.append(self.mb_view)
+        
+        # Branch menu
+        self.mb_branch = gtk.MenuItem(_i18n("_Branch"))
+        self.mb_branch_menu = gtk.Menu()
+        
+        self.mb_branch_initialize = gtk.MenuItem(_i18n("_Initialize"))
+        self.mb_branch_initialize.connect('activate', self.signal.on_menuitem_branch_initialize_activate)
+        self.mb_branch_menu.append(self.mb_branch_initialize)
+        
+        self.mb_branch_get = gtk.MenuItem(_i18n("_Get"))
+        self.mb_branch_get.connect('activate', self.signal.on_menuitem_branch_get_activate)
+        self.mb_branch_menu.append(self.mb_branch_get)
+        
+        self.mb_branch_checkout = gtk.MenuItem(_i18n("C_heckout"))
+        self.mb_branch_checkout.connect('activate', self.signal.on_menuitem_branch_checkout_activate)
+        self.mb_branch_menu.append(self.mb_branch_checkout)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_pull = gtk.ImageMenuItem(_i18n("Pu_ll"))
+        pullimage = gtk.Image()
+        pullimage.set_from_file(self.iconpath+"pull16.png")
+        self.mb_branch_pull.set_image(pullimage)
+        self.mb_branch_pull.connect('activate', self.signal.on_menuitem_branch_pull_activate)
+        self.mb_branch_menu.append(self.mb_branch_pull)
+        
+        self.mb_branch_push = gtk.ImageMenuItem(_i18n("Pu_sh"))
+        pushimage = gtk.Image()
+        pushimage.set_from_file(self.iconpath+"push16.png")
+        self.mb_branch_push.set_image(pushimage)
+        self.mb_branch_push.connect('activate', self.signal.on_menuitem_branch_push_activate)
+        self.mb_branch_menu.append(self.mb_branch_push)
+        
+        self.mb_branch_update = gtk.MenuItem(_i18n("_Update"))
+        self.mb_branch_update.connect('activate', self.signal.on_menuitem_branch_update_activate)
+        self.mb_branch_menu.append(self.mb_branch_update)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_revert = gtk.ImageMenuItem(_i18n("_Revert all changes"))
+        revertimage = gtk.Image()
+        revertimage.set_from_stock(gtk.STOCK_REVERT_TO_SAVED, gtk.ICON_SIZE_MENU)
+        self.mb_branch_revert.set_image(revertimage)
+        self.mb_branch_revert.connect('activate', self.signal.on_menuitem_branch_revert_activate)
+        self.mb_branch_menu.append(self.mb_branch_revert)
+        
+        self.mb_branch_merge = gtk.MenuItem(_i18n("_Merge"))
+        self.mb_branch_merge.connect('activate', self.signal.on_menuitem_branch_merge_activate)
+        self.mb_branch_menu.append(self.mb_branch_merge)
+        
+        self.mb_branch_commit = gtk.ImageMenuItem(_i18n("_Commit"))
+        commitimage = gtk.Image()
+        commitimage.set_from_file(self.iconpath+"commit16.png")
+        self.mb_branch_commit.set_image(commitimage)
+        self.mb_branch_commit.connect('activate', self.signal.on_menuitem_branch_commit_activate)
+        self.mb_branch_menu.append(self.mb_branch_commit)
+        
+        self.mb_branch_menu.append(gtk.SeparatorMenuItem())
+        
+        self.mb_branch_tags = gtk.ImageMenuItem(_i18n("Ta_gs"))
+        tagsimage = gtk.Image()
+        tagsimage.set_from_file(self.iconpath+"tag-16.png")
+        self.mb_branch_tags.set_image(tagsimage)
+        self.mb_branch_tags.connect('activate', self.signal.on_menuitem_branch_tags_activate)
+        self.mb_branch_menu.append(self.mb_branch_tags)
+        
+        self.mb_branch_status = gtk.MenuItem(_i18n("S_tatus"))
+        self.mb_branch_status.connect('activate', self.signal.on_menuitem_branch_status_activate)
+        self.mb_branch_menu.append(self.mb_branch_status)
+        
+        self.mb_branch_missingrevisions = gtk.MenuItem(_i18n("Missing _revisions"))
+        self.mb_branch_missingrevisions.connect('activate', self.signal.on_menuitem_branch_missing_revisions_activate)
+        self.mb_branch_menu.append(self.mb_branch_missingrevisions)
+        
+        self.mb_branch_conflicts = gtk.MenuItem(_i18n("Con_flicts"))
+        self.mb_branch_conflicts.connect('activate', self.signal.on_menuitem_branch_conflicts_activate)
+        self.mb_branch_menu.append(self.mb_branch_conflicts)
+        
+        self.mb_branch.set_submenu(self.mb_branch_menu)
+        self.mb.append(self.mb_branch)
+        
+        # Statistics menu
+        self.mb_statistics = gtk.MenuItem(_i18n("_Statistics"))
+        self.mb_statistics_menu = gtk.Menu()
+        
+        self.mb_statistics_differences = gtk.ImageMenuItem(_i18n("_Differences"))
+        diffimage = gtk.Image()
+        diffimage.set_from_file(self.iconpath+"diff16.png")
+        self.mb_statistics_differences.set_image(diffimage)
+        self.mb_statistics_differences.connect('activate', self.signal.on_menuitem_stats_diff_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_differences)
+        
+        self.mb_statistics_log = gtk.ImageMenuItem(_i18n("_Log"))
+        logimage = gtk.Image()
+        logimage.set_from_file(self.iconpath+"log16.png")
+        self.mb_statistics_log.set_image(logimage)
+        self.mb_statistics_log.connect('activate', self.signal.on_menuitem_stats_log_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_log)
+        
+        self.mb_statistics_information = gtk.MenuItem(_i18n("_Information"))
+        self.mb_statistics_information.connect('activate', self.signal.on_menuitem_stats_infos_activate)
+        self.mb_statistics_menu.append(self.mb_statistics_information)
+        
+        self.mb_statistics.set_submenu(self.mb_statistics_menu)
+        self.mb.append(self.mb_statistics)
+        
+        # Help menu
+        self.mb_help = gtk.MenuItem(_i18n("Help"))
+        self.mb_help_menu = gtk.Menu()
+        
+        self.mb_help_about = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
+        self.mb_help_about.connect('activate', self.signal.on_about_activate)
+        self.mb_help_menu.append(self.mb_help_about)
+        
+        self.mb_help.set_submenu(self.mb_help_menu)
+        self.mb.append(self.mb_help)
+    
+    def _create_toolbar(self):
+        self.tb = gtk.Toolbar()
+        
+        self.tb_refresh_icon = gtk.Image()
+        self.tb_refresh_icon.set_from_file(self.iconpath+"refresh.png")
+        self.tb_refresh = gtk.ToolButton(self.tb_refresh_icon, _i18n("Refresh"))
+        self.tb_refresh.connect('clicked', self.signal.on_menuitem_view_refresh_activate)
+        self.tb.add(self.tb_refresh)
+        
+        self.tb_diff_icon = gtk.Image()
+        self.tb_diff_icon.set_from_file(self.iconpath+"diff.png")
+        self.tb_diff = gtk.ToolButton(self.tb_diff_icon, _i18n("Diff"))
+        self.tb_diff.connect('clicked', self.signal.on_menuitem_stats_diff_activate)
+        self.tb.add(self.tb_diff)
+        
+        self.tb_log_icon = gtk.Image()
+        self.tb_log_icon.set_from_file(self.iconpath+"log.png")
+        self.tb_log = gtk.ToolButton(self.tb_log_icon, _i18n("Log"))
+        self.tb_log.connect('clicked', self.signal.on_menuitem_stats_log_activate)
+        self.tb.add(self.tb_log)
+        
+        self.tb_commit_icon = gtk.Image()
+        self.tb_commit_icon.set_from_file(self.iconpath+"commit.png")
+        self.tb_commit = gtk.ToolButton(self.tb_commit_icon, _i18n("Commit"))
+        self.tb_commit.connect('clicked', self.signal.on_menuitem_branch_commit_activate)
+        self.tb.add(self.tb_commit)
+        
+        self.tb_pull_icon = gtk.Image()
+        self.tb_pull_icon.set_from_file(self.iconpath+"pull.png")
+        self.tb_pull = gtk.ToolButton(self.tb_pull_icon, _i18n("Pull"))
+        self.tb_pull.connect('clicked', self.signal.on_menuitem_branch_pull_activate)
+        self.tb.add(self.tb_pull)
+        
+        self.tb_push_icon = gtk.Image()
+        self.tb_push_icon.set_from_file(self.iconpath+"push.png")
+        self.tb_push = gtk.ToolButton(self.tb_push_icon, _i18n("Push"))
+        self.tb_push.connect('clicked', self.signal.on_menuitem_branch_push_activate)
+        self.tb.add(self.tb_push)
+        
+        self.tb_update_icon = gtk.Image()
+        self.tb_update_icon.set_from_file(self.iconpath+"pull.png")
+        self.tb_update = gtk.ToolButton(self.tb_update_icon, _i18n("Update"))
+        self.tb_update.connect('clicked', self.signal.on_menuitem_branch_update_activate)
+        self.tb.add(self.tb_update)
+    
+    def _create_locationbar(self):
+        """ Creates the location bar, including the history widgets """
+        self.locationbar = gtk.HBox()
+        
+        self.button_location_up = gtk.Button()
+        self.button_location_up.set_relief(gtk.RELIEF_NONE)
+        image_location_up = gtk.Image()
+        image_location_up.set_from_stock(gtk.STOCK_GO_UP, gtk.ICON_SIZE_BUTTON)
+        self.button_location_up.add(image_location_up)
+        self.button_location_up.connect("clicked", self.signal.on_button_location_up_clicked)
+        self.locationbar.pack_start(self.button_location_up, False, False, 0)
+        
+        self.entry_location = gtk.Entry()
+        self.entry_location.connect("key-press-event", self.signal.on_entry_location_key_press_event)
+        self.locationbar.pack_start(self.entry_location, True, True, 0)
+        
+        self.image_location_error = gtk.Image()
+        self.image_location_error.set_from_stock(gtk.STOCK_DIALOG_ERROR, gtk.ICON_SIZE_BUTTON)
+        self.locationbar.pack_start(self.image_location_error, False, False, 0)
+        
+        self.button_location_jump = gtk.Button(stock=gtk.STOCK_JUMP_TO)
+        self.button_location_jump.set_relief(gtk.RELIEF_NONE)
+        self.button_location_jump.connect("clicked", self.signal.on_button_location_jump_clicked)
+        self.locationbar.pack_start(self.button_location_jump, False, False, 0)
+        
+        self.locationbar.pack_start(gtk.VSeparator(), False, False, 0)
+        
+        self.checkbutton_history = gtk.CheckButton(_i18n("H_istory Mode"))
+        self.checkbutton_history.connect("toggled", self.signal.on_checkbutton_history_toggled)
+        self.locationbar.pack_start(self.checkbutton_history, False, False, 0)
+        
+        self.entry_history_revno = gtk.Entry()
+        self.entry_history_revno.set_property("width-request", 75)
+        self.entry_history_revno.set_sensitive(False)
+        self.entry_history_revno.connect("key-press-event", self.signal.on_entry_history_revno_key_press_event)
+        self.locationbar.pack_start(self.entry_history_revno, False, False, 0)
+        
+        self.button_history_browse = gtk.Button()
+        self.button_history_browse.set_sensitive(False)
+        self.image_history_browse = gtk.Image()
+        self.image_history_browse.set_from_stock(gtk.STOCK_OPEN, gtk.ICON_SIZE_BUTTON)
+        self.button_history_browse.add(self.image_history_browse)
+        self.button_history_browse.connect("clicked", self.signal.on_button_history_browse_clicked)
+        self.locationbar.pack_start(self.button_history_browse, False, False, 0)
+    
+    def _create_bookmarklist(self):
+        """ Creates the bookmark list (a ListStore in a TreeView in a ScrolledWindow)"""
+        self.scrolledwindow_left = gtk.ScrolledWindow()
+        self.scrolledwindow_left.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        
+        self.treeview_left = gtk.TreeView()
+        self.treeview_left.set_headers_visible(False)
+        self.treeview_left.connect("button-press-event", self.signal.on_treeview_left_button_press_event)
+        self.treeview_left.connect("button-release-event", self.signal.on_treeview_left_button_release_event)
+        self.treeview_left.connect("row-activated", self.signal.on_treeview_left_row_activated)
+        self.scrolledwindow_left.add(self.treeview_left)
+
+        # Move olive/__init__.py _load_left List creation here
+            
+    def _create_filelist(self):
+        """ Creates the file list (a ListStore in a TreeView in a ScrolledWindow)"""
+        # Model: [ icon, dir, name, status text, status, size (int), size (human), mtime (int), mtime (local), fileid ]
+        self.scrolledwindow_right = gtk.ScrolledWindow()
+        self.scrolledwindow_right.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        
+        self.treeview_right = gtk.TreeView()
+        self.treeview_right.connect("button-press-event", self.signal.on_treeview_right_button_press_event)
+        self.treeview_right.connect("row-activated", self.signal.on_treeview_right_row_activated)
+        self.scrolledwindow_right.add(self.treeview_right)
+
+        # Move olive/__init__.py _load_right List creation here
+    
+    def set_view_to_localbranch(self, notbranch=False):
+        """ Change the sensitivity of gui items to reflect the fact that the path is a branch or not"""
+        self.mb_branch_initialize.set_sensitive(notbranch)
+        self.mb_branch_get.set_sensitive(notbranch)
+        self.mb_branch_checkout.set_sensitive(notbranch)
+        self.mb_branch_pull.set_sensitive(not notbranch)
+        self.mb_branch_push.set_sensitive(not notbranch)
+        self.mb_branch_update.set_sensitive(not notbranch)
+        self.mb_branch_revert.set_sensitive(not notbranch)
+        self.mb_branch_merge.set_sensitive(not notbranch)
+        self.mb_branch_commit.set_sensitive(not notbranch)
+        self.mb_branch_tags.set_sensitive(not notbranch)
+        self.mb_branch_status.set_sensitive(not notbranch)
+        self.mb_branch_missingrevisions.set_sensitive(not notbranch)
+        self.mb_branch_conflicts.set_sensitive(not notbranch)
+        self.mb_statistics.set_sensitive(not notbranch)
+        self.mb_statistics_differences.set_sensitive(not notbranch)
+        self.mb_file_add.set_sensitive(not notbranch)
+        self.mb_file_remove.set_sensitive(not notbranch)
+        self.mb_file_mkdir.set_sensitive(not notbranch)
+        self.mb_file_rename.set_sensitive(not notbranch)
+        self.mb_file_move.set_sensitive(not notbranch)
+        self.mb_file_annotate.set_sensitive(not notbranch)
+        self.tb_diff.set_sensitive(not notbranch)
+        self.tb_log.set_sensitive(not notbranch)
+        self.tb_commit.set_sensitive(not notbranch)
+        self.tb_pull.set_sensitive(not notbranch)
+        self.tb_push.set_sensitive(not notbranch)
+        self.tb_update.set_sensitive(not notbranch)
+    
+    def set_view_to_remotebranch(self):
+        """ Change the sensitivity of gui items to reflect the fact that the branch is remote"""
+        self.mb_file_add.set_sensitive(False)
+        self.mb_file_remove.set_sensitive(False)
+        self.mb_file_mkdir.set_sensitive(False)
+        self.mb_file_rename.set_sensitive(False)
+        self.mb_file_move.set_sensitive(False)
+        self.mb_file_annotate.set_sensitive(False)
+        self.mb_branch_initialize.set_sensitive(False)
+        self.mb_branch_get.set_sensitive(True)
+        self.mb_branch_checkout.set_sensitive(True)
+        self.mb_branch_pull.set_sensitive(False)
+        self.mb_branch_push.set_sensitive(False)
+        self.mb_branch_update.set_sensitive(False)
+        self.mb_branch_revert.set_sensitive(False)
+        self.mb_branch_merge.set_sensitive(False)
+        self.mb_branch_commit.set_sensitive(False)
+        self.mb_branch_tags.set_sensitive(True)
+        self.mb_branch_status.set_sensitive(False)
+        self.mb_branch_missingrevisions.set_sensitive(False)
+        self.mb_branch_conflicts.set_sensitive(False)
+        self.mb_statistics.set_sensitive(True)
+        self.mb_statistics_differences.set_sensitive(False)
+        self.tb_diff.set_sensitive(False)
+        self.tb_log.set_sensitive(True)
+        self.tb_commit.set_sensitive(False)
+        self.tb_pull.set_sensitive(False)
+        self.tb_push.set_sensitive(False)
+        self.tb_update.set_sensitive(False)

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2008-01-23 16:36:21 +0000
+++ revisionmenu.py	2008-07-01 21:54:21 +0000
@@ -27,7 +27,7 @@
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
-class RevisionPopupMenu(gtk.Menu):
+class RevisionMenu(gtk.Menu):
 
     __gsignals__ = {
             'tag-added': (
@@ -37,11 +37,18 @@
             )
     }
 
-    def __init__(self, repository, revids, branch=None, wt=None):
-        super(RevisionPopupMenu, self).__init__()
+    def __init__(self, repository, revids, branch=None, wt=None, parent=None):
+        super(RevisionMenu, self).__init__()
+        self._parent = parent
         self.branch = branch
         self.repository = repository
         self.wt = wt
+        self.set_revision_ids(revids)
+
+    def set_revision_ids(self, revids):
+        assert isinstance(revids, list)
+        for c in self.get_children():
+            self.remove(c)
         self.revids = revids
         self.create_items()
 
@@ -50,44 +57,55 @@
             item = gtk.MenuItem("View _Changes")
             item.connect('activate', self.show_diff)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Push")
             item.connect('activate', self.show_push)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Tag Revision")
             item.connect('activate', self.show_tag)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Merge Directive")
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
-            self.show_all()
+
+            item = gtk.MenuItem("_Send Merge Directive")
+            item.connect('activate', self.send_merge_directive)
+            self.append(item)
             
             if self.wt:
                 item = gtk.MenuItem("_Revert to this revision")
                 item.connect('activate', self.revert)
                 self.append(item)
-                self.show_all()
+
+        self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
         window = CreateMergeDirectiveDialog(self.branch, self.revids[0])
         window.show()
 
+    def send_merge_directive(self, item):
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from cStringIO import StringIO
+        window = SendMergeDirectiveDialog(self.branch, self.revids[0])
+        if window.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(window.get_merge_directive().to_lines())
+            mail_client = self.branch.get_config().get_mail_client()
+            mail_client.compose_merge_request(window.get_mail_to(), "[MERGE]",
+                                              outf.getvalue())
+        window.destroy()
+
     def show_diff(self, item):
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow(parent=self.parent)
-        parentids = self.repository.revision_parents(self.revids[0])
-
+        window = DiffWindow(parent=self._parent)
+        parentids = self.repository.get_revision(self.revids[0]).parent_ids
         if len(parentids) == 0:
             parentid = NULL_REVISION
         else:
             parentid = parentids[0]
-
         rev_tree    = self.repository.revision_tree(self.revids[0])
         parent_tree = self.repository.revision_tree(parentid)
         window.set_diff(self.revids[0], rev_tree, parent_tree)

=== modified file 'revisionview.py'
--- revisionview.py	2008-06-24 10:34:38 +0000
+++ revisionview.py	2008-06-29 19:18:34 +0000
@@ -22,9 +22,11 @@
 import gobject
 import webbrowser
 
-from bzrlib.plugins.gtk import icon_path
 from bzrlib.osutils import format_date
 from bzrlib.util.bencode import bdecode
+from bzrlib.testament import Testament
+
+from bzrlib.plugins.gtk import icon_path
 
 try:
     from bzrlib.plugins.gtk import seahorse
@@ -220,7 +222,17 @@
                                         "This revision has not been signed.")
 
     def show_signature(self, crypttext):
-        key = seahorse.verify(crypttext)
+        (cleartext, key) = seahorse.verify(crypttext)
+
+        assert cleartext is not None
+
+        inv = self.repository.get_inventory(self.revision.revision_id)
+        expected_testament = Testament(self.revision, inv).as_short_text()
+        if expected_testament != cleartext:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Signature does not match repository data</b>\n" +
+                        "The signature plaintext is different from the expected testament plaintext.")
+            return
 
         if key and key.is_available():
             if key.is_trusted():
@@ -322,8 +334,8 @@
         self._create_general()
         self._create_relations()
         # Disabled because testaments aren't verified yet:
-        # if has_seahorse:
-        #    self._create_signature()
+        if has_seahorse:
+            self._create_signature()
         self._create_file_info_view()
         self._create_bugs()
 

=== modified file 'seahorse.py'
--- seahorse.py	2008-06-20 03:33:17 +0000
+++ seahorse.py	2008-06-29 19:07:23 +0000
@@ -85,7 +85,10 @@
         if key not in keyset:
             keyset[key] = Key(key)
 
-        return keyset[key]
+        return (cleartext, keyset[key])
+
+    return (cleartext, None)
+
 
 class Key:
 

=== added file 'search.py'
--- search.py	1970-01-01 00:00:00 +0000
+++ search.py	2008-07-01 15:28:30 +0000
@@ -0,0 +1,88 @@
+# Copyright (C) 2008 by Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gobject, gtk
+from bzrlib.plugins.search import index as _mod_index
+
+
+class SearchDialog(gtk.Dialog):
+    """Search dialog."""
+    def __init__(self, branch, parent=None):
+        gtk.Dialog.__init__(self, title="Search Revisions",
+                                  parent=parent,
+                                  flags=gtk.DIALOG_MODAL,
+                                  buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+    
+        # Get arguments
+        self.branch = branch
+
+        self.index = _mod_index.open_index_url(branch.base)
+
+        self.searchbar = gtk.HBox()
+        self.searchentry = gtk.Entry()
+        self.searchentry.connect('activate', self._searchentry_activate)
+        # TODO: Completion using the bzr-search suggests functionality
+        self.searchbar.add(self.searchentry)
+        self.vbox.pack_start(self.searchbar, expand=False, fill=False)
+
+        self.results_model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
+        self.results_treeview = gtk.TreeView(self.results_model)
+
+        documentname_column = gtk.TreeViewColumn("Document", gtk.CellRendererText(), text=0)
+        self.results_treeview.append_column(documentname_column)
+
+        summary_column = gtk.TreeViewColumn("Summary", gtk.CellRendererText(), text=1)
+        self.results_treeview.append_column(summary_column)
+
+        results_scrolledwindow = gtk.ScrolledWindow()
+        results_scrolledwindow.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
+        results_scrolledwindow.add(self.results_treeview)
+
+        self.vbox.pack_start(results_scrolledwindow, expand=True, fill=True)
+
+        self.set_default_size(600, 400)
+        # Show the dialog
+        self.show_all()
+
+    def get_revision(self):
+        (path, focus) = self.results_treeview.get_cursor()
+        if path is None:
+            return None
+        iter = self.results_model.get_iter(path)
+        return self.results_model.get_value(iter, 2)
+
+    def _searchentry_activate(self, entry):
+        self.results_model.clear()
+        self.index._branch.lock_read()
+        try:
+            query = [(query_item,) for query_item in self.searchentry.get_text().split(" ")]
+            for result in self.index.search(query):
+                if isinstance(result, _mod_index.FileTextHit):
+                    revid = result.text_key[-1]
+                elif isinstance(result, _mod_index.RevisionHit):
+                    revid = result.revision_key[0]
+                else:
+                    raise AssertionError()
+                self.results_model.append([result.document_name(), result.summary(), revid])
+        finally:
+            self.index._branch.unlock()

=== modified file 'setup.py'
--- setup.py	2008-06-27 16:53:56 +0000
+++ setup.py	2008-06-27 17:32:10 +0000
@@ -96,7 +96,7 @@
     maintainer_email = "jelmer@samba.org",
     description = "GTK+ Frontends for various Bazaar commands",
     license = "GNU GPL v2 or later",
-    scripts=['olive-gtk', 'bzr-handle-patch'],
+    scripts=['olive-gtk', 'bzr-handle-patch', 'bzr-notify'],
     package_dir = {
         "bzrlib.plugins.gtk": ".",
         "bzrlib.plugins.gtk.viz": "viz", 

=== modified file 'status.py'
--- status.py	2008-05-05 18:16:46 +0000
+++ status.py	2008-07-08 21:40:38 +0000
@@ -28,12 +28,13 @@
     """ Display Status window and perform the needed actions. """
     def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
-        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
+        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
         self.set_title("Working tree changes")
+        self.set_default_response(gtk.RESPONSE_CLOSE)
         self._create()
         self.wt = wt
         self.wtpath = wtpath
-        
+
         if revision is None:
             revision = self.wt.branch.last_revision()
             
@@ -44,13 +45,22 @@
 
     def _create(self):
         self.set_default_size(400, 300)
-        scrolledwindow = gtk.ScrolledWindow()
-        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self.set_has_separator(False)
+        sw = gtk.ScrolledWindow()
+        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw.set_shadow_type(gtk.SHADOW_IN)
         self.treeview = gtk.TreeView()
-        scrolledwindow.add(self.treeview)
-        self.vbox.pack_start(scrolledwindow, True, True)
+        sw.add(self.treeview)
+        self.vbox.pack_start(sw, True, True)
         self.vbox.show_all()
 
+        # sane border and spacing widths (as recommended by GNOME HIG) 
+        self.set_border_width(5)
+        sw.set_border_width(5)
+        self.vbox.set_spacing(2)
+        self.action_area.set_border_width(5)
+
+
     def row_diff(self, tv, path, tvc):
         file = self.model[path][1]
         if file is None:
@@ -61,6 +71,7 @@
         window.set_file(file)
         window.show()
 
+
     def _generate_status(self):
         """ Generate 'bzr status' output. """
         self.model = gtk.TreeStore(str, str)

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2008-06-29 15:54:40 +0000
+++ tests/__init__.py	2008-06-29 22:44:42 +0000
@@ -32,9 +32,6 @@
         'test_history',
         ]
 
-    if os.name == 'nt':
-        testmod_names.append("test_tortoise_bzr")
-
     result.addTest(loader.loadTestsFromModuleNames(["%s.%s" % (__name__, i) for i in testmod_names]))
     return result
 

=== removed file 'tests/test_tortoise_bzr.py'
--- tests/test_tortoise_bzr.py	2007-03-15 12:43:48 +0000
+++ tests/test_tortoise_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib import config
-
-import win32com.client as client
-
-class TestsShellExtension(TestCaseInTempDir):
-    def setUp(self):
-        super(TestsUrlHistory, self).setUp()
-        self.ext = client.Dispatch("Bazaar.ShellExtension.ContextMenu")
-
-    def test_get_command_string(self):
-        self.assertEqual(u"Hello from Python!!", self.ext.GetCommandString(1,1))

=== modified file 'ui.py'
--- ui.py	2008-06-29 16:11:12 +0000
+++ ui.py	2008-06-30 20:32:25 +0000
@@ -22,7 +22,7 @@
 import gtk
 import sys
 
-import bzrlib.progress
+from bzrlib import progress
 from bzrlib.ui import UIFactory
 
 
@@ -40,60 +40,116 @@
                          gtk.RESPONSE_NO)
 
 
-class GtkProgressBar(gtk.ProgressBar):
-    def __init__(self, stack):
-        super(GtkProgressBar, self).__init__()
+class GtkProgressBar(gtk.ProgressBar,progress._BaseProgressBar):
+    def __init__(self, _stack=None):
+        gtk.ProgressBar.__init__(self)
         self.set_fraction(0.0)
-        self._stack = stack
+        progress._BaseProgressBar.__init__(self, _stack=_stack)
         self.current = None
         self.total = None
 
-    def finished(self):
-        self._stack.remove(self)
-
     def clear(self):
-        pass
+        self.hide()
 
     def tick(self):
         self.pulse()
 
-    def update(self, msg=None, current=None, total=None):
-        if current:
-            self.current = current
-        if total:
-            self.total = total
+    def child_update(self, message, current, total):
+        pass
+
+    def update(self, msg=None, current_cnt=None, total_cnt=None):
+        if current_cnt:
+            self.current = current_cnt
+        if total_cnt:
+            self.total = total_cnt
         if msg is not None:
             self.set_text(msg)
         if None not in (self.current, self.total):
-            self.set_fraction(1.0 * self.current / self.total)
+            self.fraction = float(self.current) / self.total
+            self.set_fraction(self.fraction)
         while gtk.events_pending():
             gtk.main_iteration()
 
 
-class GtkProgressBarStack(gtk.Window):
-    def __init__(self):
-        super(GtkProgressBarStack, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+class ProgressBarWindow(gtk.Window):
+    def __init__(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                 show_bar=None, show_count=None, to_messages_file=None, _stack=None):
+        super(ProgressBarWindow, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+        self._stack = _stack
         self.set_border_width(0)
         self.set_title("Progress")
         self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
-        self.vbox = gtk.VBox()
-        self.add(self.vbox)
+        self.pb = GtkProgressBar(self)
+        self.add(self.pb)
+        self.resize(250, 15)
         self.set_resizable(False)
-
-    def _adapt_size(self):
-        self.resize(250, 15 * len(self.vbox.get_children()))
-
-    def get_nested(self):
-        nested = GtkProgressBar(self)
-        self.vbox.pack_start(nested)
-        self._adapt_size()
-        self.show_all()
-        return nested
-
-    def remove(self, pb):
-        self.vbox.remove(pb)
-        if len(self.vbox.get_children()) == 0: # If there is nothing to show, don't leave a ghost window here
-             self.destroy()
+        self.show_all()
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+ 
+    def clear(self):
+        self.pb.clear()
+        self.destroy()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
+    def get_progress_bar(self):
+        self.show_all()
+        return self
+
+
+class ProgressPanel(gtk.HBox):
+    def __init__(self):
+        super(ProgressPanel, self).__init__()
+        image_loading = gtk.image_new_from_stock(gtk.STOCK_REFRESH,
+                                                 gtk.ICON_SIZE_BUTTON)
+        image_loading.show()
+        
+        self.pb = GtkProgressBar(self)
+        self.set_spacing(5)
+        self.set_border_width(5)        
+        self.pack_start(image_loading, False, False)
+        self.pack_start(self.pb, True, True)
+
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+
+    def get_progress_bar(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                         show_bar=None, show_count=None, to_messages_file=None, 
+                         _stack=None):
+        self._stack = _stack
+        self.show_all()
+        return self
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide_all()
+
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
 
 
 class PasswordDialog(gtk.Dialog):
@@ -128,7 +184,7 @@
 
         """
         super(GtkUIFactory, self).__init__()
-        self._progress_bar_stack = None
+        self.set_nested_progress_bar_widget(ProgressBarWindow)
 
     def get_boolean(self, prompt):
         """GtkDialog with yes/no answers"""
@@ -156,11 +212,12 @@
         else:
             return None
 
+    def set_nested_progress_bar_widget(self, widget):
+        self._progress_bar_stack = progress.ProgressBarStack(klass=widget)
+
     def nested_progress_bar(self):
         """Return a nested progress bar.
         """
-        if self._progress_bar_stack is None:
-            self._progress_bar_stack = GtkProgressBarStack()
         return self._progress_bar_stack.get_nested()
 
     def set_progress_bar_vbox(self, vbox):

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2008-07-01 21:54:21 +0000
@@ -13,14 +13,16 @@
 import gobject
 import pango
 
-from bzrlib.plugins.gtk.window import Window
 from bzrlib.plugins.gtk import icon_path
+from bzrlib.plugins.gtk.branchview import TreeView, treemodel
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
-from bzrlib.plugins.gtk.branchview import TreeView, treemodel
+from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
+from bzrlib.plugins.gtk.window import Window
+
+from bzrlib.config import BranchConfig, GlobalConfig
 from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
-from bzrlib.config import GlobalConfig
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -202,24 +204,9 @@
         go_menu.add(gtk.SeparatorMenuItem())
         go_menu.add(self.go_menu_tags)
 
-        revision_menu = gtk.Menu()
+        self.revision_menu = RevisionMenu(self.branch.repository, [], self.branch, parent=self)
         revision_menuitem = gtk.MenuItem("_Revision")
-        revision_menuitem.set_submenu(revision_menu)
-
-        revision_menu_diff = gtk.MenuItem("View Changes")
-        revision_menu_diff.connect('activate', 
-                self._menu_diff_cb)
-        
-        revision_menu_compare = gtk.MenuItem("Compare with...")
-        revision_menu_compare.connect('activate',
-                self._compare_with_cb)
-
-        revision_menu_tag = gtk.MenuItem("Tag Revision")
-        revision_menu_tag.connect('activate', self._tag_revision_cb)
-
-        revision_menu.add(revision_menu_tag)
-        revision_menu.add(revision_menu_diff)
-        revision_menu.add(revision_menu_compare)
+        revision_menuitem.set_submenu(self.revision_menu)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -228,6 +215,21 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_menu.add(gtk.SeparatorMenuItem())
+
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
+            branch_search_menuitem = gtk.MenuItem("_Search")
+            branch_search_menuitem.connect('activate', self._branch_search_cb)
+            branch_menu.add(branch_search_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -319,6 +321,8 @@
         parents  = self.treeview.get_parents()
         children = self.treeview.get_children()
 
+        self.revision_menu.set_revision_ids([revision.revision_id])
+
         if revision and revision != NULL_REVISION:
             prev_menu = gtk.Menu()
             if len(parents) > 0:
@@ -378,19 +382,6 @@
         self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
         
-    def _menu_diff_cb(self,w):
-        (path, focus) = self.treeview.treeview.get_cursor()
-        revid = self.treeview.model[path][treemodel.REVID]
-        
-        parentids = self.branch.repository.revision_parents(revid)
-
-        if len(parentids) == 0:
-            parentid = NULL_REVISION
-        else:
-            parentid = parentids[0]
-        
-        self.show_diff(revid,parentid)    
-
     def _back_clicked_cb(self, *args):
         """Callback for when the back button is clicked."""
         self.treeview.back()
@@ -409,22 +400,6 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
-    def _compare_with_cb(self,w):
-        """Callback for revision 'compare with' menu. Will show a small
-            dialog with branch revisions to compare with selected revision in TreeView"""
-        
-        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-        
-        rb = RevisionBrowser(self.branch,self)
-        ret = rb.run()
-        
-        if ret == gtk.RESPONSE_OK:          
-            (path, focus) = self.treeview.treeview.get_cursor()
-            revid = self.treeview.model[path][treemodel.REVID]
-            self.show_diff(revid, rb.selected_revid)
-            
-        rb.destroy()
-            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 
@@ -440,21 +415,18 @@
         self.treeview.set_property('compact', self.compact_view)
         self.treeview.refresh()
 
-    def _tag_revision_cb(self, w):
-        try:
-            self.treeview.set_sensitive(False)
-            dialog = AddTagDialog(self.branch.repository, self.treeview.get_revision().revision_id, self.branch)
-            response = dialog.run()
-            if response != gtk.RESPONSE_NONE:
-                dialog.hide()
-            
-                if response == gtk.RESPONSE_OK:
-                    self.treeview.add_tag(dialog.tagname, dialog._revid)
-                
-                dialog.destroy()
-
-        finally:
-            self.treeview.set_sensitive(True)
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
+    def _branch_search_cb(self, w):
+        from bzrlib.plugins.gtk.search import SearchDialog
+        dialog = SearchDialog(self.branch)
+        
+        if dialog.run() == gtk.RESPONSE_OK:
+            self.set_revision(dialog.get_revision())
+
+        dialog.destroy()
 
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog

